<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
if (!defined("IN_FUSION") || !checkrights("I")) { header("Location: ../../index.php"); exit; }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."master_download_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."master_download_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."master_download_panel/locale/Polish.php";
}

// Infusion general information
$inf_title = $locale['mdp100'];
$inf_description = $locale['mdp101'];
$inf_version = "1.0";
$inf_developer = "M@ster";
$inf_email = "master@bbproject.net";
$inf_weburl = "http://www.bbproject.net";

$inf_folder = "master_download_panel"; // The folder in which the infusion resides.
$inf_admin_image = "master_download_panel.gif"; // Leave blank to use the default image.
$inf_admin_panel = "master_download_admin.php"; // The admin panel filename if required.

$inf_link_name = ""; // if not required replace $locale['xxx102']; with "";
$inf_link_url = ""; // The filename you wish to link to.
$inf_link_visibility = "0"; // 0 - Guest / 101 - Member / 102 - Admin / 103 - Super Admin.

$inf_newtables = 4; // Number of new db tables to create or drop.
$inf_insertdbrows = 0; // Numbers rows added into created db tables.
$inf_altertables = 0; // Number of db tables to alter (upgrade).
$inf_deldbrows = 0; // Number of db tables to delete data from.

// Delete any items not required here.
$inf_newtable_[1] = "master_download_files (
file_id SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
file_cat SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
file_shortcut VARCHAR(20) NOT NULL DEFAULT '',
file_name VARCHAR(100) NOT NULL DEFAULT '',
file_desc TEXT NOT NULL DEFAULT '',
file_url VARCHAR(200) NOT NULL DEFAULT '',
file_img VARCHAR(200) NOT NULL DEFAULT '',
file_size INT(10) UNSIGNED NOT NULL DEFAULT '0',
file_count INT(10) UNSIGNED NOT NULL DEFAULT '0',
file_date INT(10) UNSIGNED NOT NULL DEFAULT '0',
file_order SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (file_id)
) TYPE=MyISAM;";

$inf_newtable_[2] = "master_download_cats (
cat_id SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
cat_name VARCHAR(100) NOT NULL DEFAULT '',
cat_desc TEXT NOT NULL DEFAULT '',
cat_count SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
cat_order SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (cat_id)
) TYPE=MyISAM;";

$inf_newtable_[3] = "master_download_mirrors (
mirror_id SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
mirror_name VARCHAR(100) NOT NULL DEFAULT '',
mirror_url VARCHAR(200) NOT NULL DEFAULT '',
mirror_used INT(10) UNSIGNED NOT NULL DEFAULT '0',
mirror_limit INT(10) UNSIGNED NOT NULL DEFAULT '0',
mirror_lastdown INT(10) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (mirror_id)
) TYPE=MyISAM;";

$inf_newtable_[4] = "master_download_rels (
rel_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
rel_fileid SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
rel_mirrorid SMALLINT(5) UNSIGNED NOT NULL DEFAULT '0',
rel_url VARCHAR(200) NOT NULL DEFAULT '',
PRIMARY KEY (rel_id)
) TYPE=MyISAM;";

$inf_droptable_[1] = "master_download_files";
$inf_droptable_[2] = "master_download_cats";
$inf_droptable_[3] = "master_download_mirrors";
$inf_droptable_[4] = "master_download_rels";

?>